/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */

#ifndef APPLICATION_H_
#define APPLICATION_H_

#include "kernel.h"

namespace hydra
{
class IInput;
class IWindow;

class IView;

/** framework class
 * @remarks
 * @note
 */

class LIBAPI Application: public Kernel
{
public:
    Application();
    virtual ~Application();

public:
	virtual bool create();
	
	//
    bool update();
	void draw();
	void present();

	//
    int run();

    // property
public:
	inline void setView(IView * view)	{ m_view = view; }

    //
	inline IInput * getInput()	{ return m_input; }
	inline IWindow * getWindow()	{ return m_window; }
	
    inline float getFPS() 	{ return m_framesPerSecond; }

protected:
	virtual bool loadModule();

	virtual bool onUpdate(float deltaTime);
	virtual void onDraw();

protected:
	float m_framesPerSecond;
	unsigned long m_frameCounter;

	IInput * m_input;
	IWindow * m_window;

	/// active view
	IView * m_view;
};

} //hydra

#endif //APPLICATION_H_
