/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */

#ifndef IVOICE_H_
#define IVOICE_H_

#include "iunknown.h"

namespace hydra
{

class LIBAPI IVoice: public IUnknown
{
    DECLARE_BASE_MODULE(IVoice)

public:
    IVoice();

    virtual bool loadFromFile(const char * pathName) = 0;

    virtual bool play(int mode) = 0;
    virtual void stop() = 0;

    virtual void update() = 0;
	
	virtual void setVolume(int volume);
};

DEFINE_BASE_MODULE(IVoice, Voice)
DEFINE_BASE_LOAD_MODULE(IVoice, Voice)

} //hydra

#endif //IVOICE_H_
