/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */

#ifndef ICGSHADER_H_
#define ICGSHADER_H_

#include "ishader.h"

#include "igraphics.h" // for _NVCG

#if defined(_NVCG)

namespace hydra
{

class LIBAPI ICgShader: public IShader
{
public:
	ICgShader();
	virtual ~ICgShader();

public:

	//
	virtual void setFloat(const char * name, const float value);
	virtual void setFloatArray(const char * name, const float * value, int count);

	virtual void setVector(const char * name, const float4 & value);
	virtual void setVectorArray(const char * name, const float4 * value, int count);

	virtual void setMatrix(const char * name, const float4x4 & value);
	virtual void setMatrixArray(const char * name, const float4x4 * value, int count);

protected:
	CGprogram m_fragmentProgram;		// pixel shader inputs
	CGprogram m_vertexProgram;			// vertex shader inputs
};

} //hydra

#endif //_NVCG

#endif //ICGSHADER_H_
