/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */

#ifndef IIMAGE_H_
#define IIMAGE_H_

#include "iunknown.h"

namespace hydra
{

class LIBAPI IImage: public IUnknown
{
    DECLARE_BASE_MODULE(IImage)

public:
	IImage();
	virtual ~IImage();

    bool create(int width, int height, unsigned long format, int mipLevels);

    //
    bool loadFromFile(const char * pathName);

protected:
	virtual bool decode(void * data) = 0;

	// property
public:
	inline unsigned long getFormat()	{ return m_format; }

	//
	inline int getWidth() 	{ return m_width; }
	inline int getHeight() 	{ return m_height; }

	//
	inline int getPitch()	{ return m_pitch; }
	inline int getMipLevels()	{ return m_mipLevels; }

	// 
	inline void * getBits()		{ return m_bits; }
	inline int getLinerSize()	{ return m_linearSize; }

protected:
	unsigned long m_format;

	int m_width, m_height;
	int m_pitch;
	int m_mipLevels;

	void * m_bits;
	int m_linearSize;
};

//
DEFINE_BASE_MODULE(IImage, Image)
DEFINE_BASE_LOAD_MODULE(IImage, Image)

} //hydra

#endif //IIMAGE_H_
