/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */

#ifndef IINDEXBUFFER_H_
#define IINDEXBUFFER_H_

#include "iunknown.h"

namespace hydra
{
class IVertexbuffer;

class LIBAPI IIndexbuffer: public IUnknown
{
    DECLARE_BASE_MODULE(IIndexbuffer)

public:
	IIndexbuffer();

    virtual bool create(int length, unsigned long format);

	//
	virtual void * map() = 0;
	virtual void unmap() = 0;

	//
	virtual void bind() = 0;

	//
	virtual void draw(int primitiveType) = 0;

	virtual void draw(int primitiveType, unsigned int startIndex, unsigned int indexCount, unsigned int numVertices) = 0;
	virtual void draw(int primitiveType, unsigned int startVertex, unsigned int numVertices, unsigned int startIndex, unsigned int indexCount) = 0;

    // property
public:
    inline int getLength() 				{ return m_length; }
    inline unsigned long getFormat()	{ return m_format; }

protected:
	unsigned long m_format;
    int m_length;
};

//
DEFINE_BASE_MODULE(IIndexbuffer, Indexbuffer)

//
inline IIndexbuffer * createIndexbuffer(int length, unsigned long fvf)
{
    IIndexbuffer * ib = createIndexbuffer();
    bool result = ib->create(length, fvf);
	ASSERT(result)

    return ib;
}

} //hydra

#endif //IINDEXBUFFER_H_
