/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */

#ifndef ISHADER_H_
#define ISHADER_H_

#include "iunknown.h"

#include "vector.h"

namespace hydra
{
class ISampler;

class LIBAPI IShader: public IUnknown
{
    DECLARE_BASE_MODULE(IShader)

public:
	IShader();

    virtual bool loadFromFile(const char * pathName);

	virtual bool loadFromMemory(const char * code) = 0;
    virtual bool loadFromMemory(const char * vpcode, const char * fpcode) = 0;

    //
    virtual void begin() = 0;
	virtual void end() = 0;

	//
	virtual void setSampler(int stage, ISampler * sampler) = 0;
	virtual void setSamplerState(unsigned long sampler, int type, unsigned long value) = 0;

	//
	virtual void setFloat(const char * name, const float value) = 0;
	virtual void setFloatArray(const char * name, const float * value, int count) = 0;

	virtual void setVector(const char * name, const float4 & value) = 0;
	virtual void setVectorArray(const char * name, const float4 * value, int count) = 0;

	virtual void setMatrix(const char * name, const float4x4 & value) = 0;
	virtual void setMatrixArray(const char * name, const float4x4 * value, int count) = 0;

protected:
	const char * m_ext;
};

//
DEFINE_BASE_MODULE(IShader, Shader)
DEFINE_BASE_LOAD_MODULE(IShader, Shader)

} //hydra

#endif //ISHADER_H_
