/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */

#ifndef LINKEDLIST_H_
#define LINKEDLIST_H_

#include "iunknown.h"

namespace hydra
{

/** linkedlist class.
 * @remarks
 * @note
 */
class LIBAPI Linkedlist
{
public:
	/** linkedlist node structor.
	 * @remarks
	 * @note
	 */
	struct Node {
	    Node(IUnknown * _unknown)
	    {
	        unknown = _unknown;
	    }

		Node * prev;
	    Node * next;

	    //
	    IUnknown * unknown;
	};

public:
    Linkedlist();
    virtual ~Linkedlist();

public:
	/** Insert last
	 */
	bool add(IUnknown * unknown);

	void removeNode(Node * node);
	void removeLink(Node * node);
	void removeAll();

	Linkedlist::Node * find(IUnknown * unknown);
	void remove(IUnknown * unknown);

	// property
public:
	//
	inline Node * getFirst()	{ return m_first; }
	inline Node * getLast()		{ return m_last; }

	inline int getCount()		{ return m_count; }

protected:
	bool insertAfter(Node * node, IUnknown * unknown);
	bool insertBefore(Node * node, IUnknown * unknown);

protected:
    int m_count;

    Node * m_first;
    Node * m_last;
};

} //hydra

#endif //LINKEDLIST_H_
