/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */

#ifndef MODULE_H_
#define MODULE_H_

#include "stdafx.h"

namespace hydra
{

#include "moduleinfo.h"

/** Module class.
 * @remarks
 * @note
 */
class LIBAPI Module
{
private:
#if defined(_WIN32)
	HMODULE m_handle;
#elif defined(__APPLE__) || defined(_LINUX)
	void * m_handle;
#endif //_WIN32

public:
	typedef void * (*PFNLOADMODULEPROC)();
	typedef void (*PFNUNLOADMODULEPROC)();
	typedef const MODULEINFO * (*PFNGETMODULEINFOPROC)();

	///
	PFNLOADMODULEPROC pfnload;
	PFNUNLOADMODULEPROC pfnunload;

	PFNGETMODULEINFOPROC pfngetInfo;

public:
	Module();
	virtual ~Module();

public:
	/** loadFromFile
	 * @param pathName Module file path.
	 * @returns
	 */
	bool loadFromFile(const char * pathName);

	//
	void dump();

	//property
public:
	void * getModule()	{ return m_pmodule; }

private:
	void * getSymbol(const char * name);

private:
	void * m_pmodule;
};

} //hydra

#endif //MODULE_H_
