/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */

#ifndef STDAFX_H_
#define STDAFX_H_

#if !defined(PLATFORMNAME)
	#define PLATFORMNAME	"HYDRA"
#endif //PLATFORMNAME

// finds the compiler type and version.
#if defined(_MSC_VER)
	#define COMPILER_NAME "MSVC"
	#define COMPILER_VER _MSC_VER
#elif defined(__GNUC__)
	#define COMPILER_NAME "GNUC"
	#define COMPILER_VER (((__GNUC__) * 100) + (__GNUC_MINOR__ * 10) + __GNUC_PATCHLEVEL__)
#elif defined( __BORLANDC__ )
	#define COMPILER_NAME "BORLAND"
	#define COMPILER_VER __BCPLUSPLUS__
#else
	#pragma error "no known compiler. Abort! Abort!"
#endif

// see if we can use __forceinline or if we need to use __inline instead
#if (_MSC_VER >= 1200)
	#define FORCEINLINE __forceinline
#elif defined(__MINGW32__)
	#if !defined(FORCEINLINE)
		#define FORCEINLINE __inline
	#endif
#else
	#define FORCEINLINE __inline
#endif


// find the arch type
#if defined(__x86_64__) || defined(_M_X64) || defined(__powerpc64__) || defined(__alpha__) || defined(__ia64__) || defined(__s390__) || defined(__s390x__)
	#define ARCH_TYPE 64
#else
	#define ARCH_TYPE 32
#endif

//
#if defined(SN_TARGET_PSP_HW) || defined(SN_TARGET_PSP_PRX)
	#define _PSP
#endif //SN_TARGET_PSP_HW

#if defined(_WIN32)
	// STRICT is the only supported option (NOSTRICT is no longer supported)
	#ifndef STRICT
		#define STRICT
	#endif //STRICT

	// If app hasn't choosen, set to work with Windows 98, Windows Me, Windows 2000, Windows XP and beyond
	#ifndef WINVER
		#define WINVER         0x0410
	#endif //WINVER

	#ifndef _WIN32_WINDOWS
		#define _WIN32_WINDOWS 0x0410
	#endif //_WIN32_WINDOWS

	#ifndef _WIN32_WINNT
		#define _WIN32_WINNT   0x0500
	#endif //_WIN32_WINNT

	#if defined(_MSC_VER)
		#if !defined(_CRT_SECURE_NO_DEPRECATE)
			#define _CRT_SECURE_NO_DEPRECATE
		#endif //_CRT_SECURE_NO_DEPRECATE
	#endif //_MSC_VER

	#if defined(_MSC_VER)
		//#pragma warning(disable : 4115) /* named type definition in parentheses */
		#pragma warning(disable : 4100) // disable unreference formal parameter warnings for /W4 builds
	#endif //_MSC_VER

	#define WIN32_LEAN_AND_MEAN		// Exclude rarely-used stuff from Windows headers
	#include <windows.h>
	#include <wchar.h>
	#include <mmsystem.h>
	#include <commctrl.h> // for InitCommonControls()
	#include <shellapi.h> // for ExtractIcon()
	#include <new.h>      // for placement new
	#include <math.h>
	#include <limits.h>
	#undef WIN32_LEAN_AND_MEAN

	//
	#include <mmsystem.h>		// timeGetTime()
	#define TIMER	(float) timeGetTime()

	#if defined (_MSC_VER)
		#pragma comment(lib, "winmm.lib")
	#endif //_MSC_VER

	// CRT's memory leak detection
	#if defined(DEBUG) || defined(_DEBUG)
		#if defined(_MSC_VER)
			#include <crtdbg.h>
		#endif //_MSC_VER
	#endif //DEBUG

	// strsafe.h deprecates old unsecure string functions.  If you
	// really do not want to it to (not recommended), then uncomment the next line
	#define STRSAFE_NO_DEPRECATE

	#ifndef STRSAFE_NO_DEPRECATE
	#pragma deprecated("strncpy")
	#pragma deprecated("wcsncpy")
	#pragma deprecated("_tcsncpy")
	#pragma deprecated("wcsncat")
	#pragma deprecated("strncat")
	#pragma deprecated("_tcsncat")
	#endif //STRSAFE_NO_DEPRECATE

	#if defined (_MSC_VER)
		#pragma warning(disable : 4996) // disable deprecated warning
		#include <strsafe.h>
		#pragma warning(default : 4996)
	#endif //_MSC_VER

	//
	#if defined(_USRDLL)
		#define LIBAPI __declspec(dllexport)
	#else
		#if defined(__MINGW32__)
			#define LIBAPI
		#else
			#define LIBAPI __declspec(dllimport)
		#endif
	#endif //_USRDLL

	// MSVC _LIB
	#if defined(_LIB)
		#undef LIBAPI
		#define LIBAPI
	#endif

	//
	#define LIBEXPORT extern "C" __declspec(dllexport)

	//
	#define PLATFORM "WIN32"

	// disable unicode support on MingW at the moment, poorly supported in stdlibc++
	// STLPORT fixes this though so allow if found
	// MinGW C++ Toolkit supports unicode and sets the define __MINGW32_TOOLKIT_UNICODE__ in _mingw.h
	#if defined(__MINGW32__) && !defined(_STLPORT_VERSION)
		#include <_mingw.h>
		#if defined(__MINGW32_TOOLBOX_UNICODE__)
			#define UNICODE_SUPPORT 1
		#else
			#define UNICODE_SUPPORT 0
		#endif
	#elif defined (_MSC_VER)
		#ifdef UNICODE
			#define UNICODE_SUPPORT 1

			#error "Requires a Multibyte build. See the nearby comments for details"
			//#error "Requires a Unicode build. See the nearby comments for details"
			//
			// If you are using Microsoft Visual C++ .NET, under the General tab of the project
			// properties change the Character Set to 'Use Unicode Character Set'.
			//
			// Windows XP and later are native Unicode so Unicode applications will perform better.
			// For Windows 98 and Windows Me support, consider using the Microsoft Layer for Unicode (MSLU).
			//
			// To use MSLU, link against a set of libraries similar to this
			//      /nod:kernel32.lib /nod:advapi32.lib /nod:user32.lib /nod:gdi32.lib /nod:shell32.lib /nod:comdlg32.lib /nod:version.lib /nod:mpr.lib /nod:rasapi32.lib /nod:winmm.lib /nod:winspool.lib /nod:vfw32.lib /nod:secur32.lib /nod:oleacc.lib /nod:oledlg.lib /nod:sensapi.lib UnicoWS.lib kernel32.lib advapi32.lib user32.lib gdi32.lib shell32.lib comdlg32.lib version.lib mpr.lib rasapi32.lib winmm.lib winspool.lib vfw32.lib secur32.lib oleacc.lib oledlg.lib sensapi.lib dxerr.lib dxguid.lib d3dx9d.lib d3d9.lib comctl32.lib
			// and put the unicows.dll (available for download from msdn.microsoft.com) in the exe's folder.
			//
			// For more details see the MSDN article titled:
			// "MSLU: Develop Unicode Applications for Windows 9x Platforms with the Microsoft Layer for Unicode"
			// at http://msdn.microsoft.com/msdnmag/issues/01/10/MSLU/default.aspx
		#else
			#define UNICODE_SUPPORT 0
		#endif //UNICODE
	#endif
//#endif //_WIN32
#elif defined(__APPLE__)
	#define TIMER ((float) getTickCount())

	#define LIBAPI

	//
	#define LIBEXPORT extern "C"

	//
	#define PLATFORM "DARWIN"

	// always enable unicode support for the moment
	// perhaps disable in old versions of gcc if necessary
	#define UNICODE_SUPPORT 1

	typedef WindowRef	HWND;
//#endif //__APPLE__
#elif defined(_XBOX)
	#include <xtl.h>
	#include <ppcintrinsics.h>

	#define TIMER	(float) GetTickCount()

	//
	#define LIBAPI

	//
	#define LIBEXPORT extern "C"

	//
	#define PLATFORM "XENON"

	//
	#define UNICODE_SUPPORT 0

	typedef int		HWND;
//#endif //_XBOX
#elif defined(_PS3)
	#include <sys/sys_time.h>
	#define TIMER ((float) sys_time_get_system_time() * 0.001f)

	#if defined(_USEPSGL)
	#define _NVCG
	#endif //_USEPSGL

	//
	#define LIBAPI

	//
	#define LIBEXPORT extern "C"

	//
	#define PLATFORM "PS3"

	//
	#define UNICODE_SUPPORT 0

	typedef int		HWND;
//#endif //_PS3
#elif defined(_PSP)
	#include <kernel.h>
	#include <psptypes.h>

	#define TIMER ((float) sceKernelGetSystemTimeLow() * 0.001f)

	//
	#define LIBAPI

	//
	#define LIBEXPORT extern "C"

	//
	#define PLATFORM "PSP"

	//
	#define UNICODE_SUPPORT 0

	typedef int		HWND;
//#endif //_PSP
#else //_LINUX
	#include <X11/Xlib.h>
	#include <X11/Xutil.h>

	// Headers needed for keys used in the program
	#include <X11/extensions/xf86vmode.h>
	#include <X11/keysym.h>

	#define TIMER ((float) getTickCount())

	#define _LINUX

	//
	#define LIBAPI

	//
	#define LIBEXPORT extern "C"

	//
	#define PLATFORM "LINUX"

	//
	#define UNICODE_SUPPORT 0

	typedef Display * HWND;
#endif //_LINUX

#include <assert.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

//
#if !defined(__APPLE__)
#include <malloc.h> // for malloc
#endif

//
#if defined (_MSC_VER)
	// C4127: conditional expression is constant
	#pragma warning(disable:4127)
#endif //_MSC_VER

//
typedef unsigned long	color;
typedef int				fixed;

//
#if !defined(min)
	#define min(a, b)  (((a) < (b)) ? (a) : (b))
#endif //min

//
#if !defined(max)
	#define max(a, b)  (((a) > (b)) ? (a) : (b))
#endif //max

//
#if !defined(NULL)
	#define NULL 0
#endif //NULL

#if !defined(BOOL)
	#define BOOL int

	#if !defined(FALSE)
		#define FALSE 0
	#endif //FALSE

	#if !defined(TRUE)
		#define TRUE 1
	#endif //TRUE
#endif //BOOL

//
#if !defined(MAX_PATH)
	#define MAX_PATH	(260)
#endif //MAX_PATH

//
#if !defined(MAX_NAME)
	#define MAX_NAME	(20)
#endif //MAX_NAME

//
#ifndef SAFE_DELETE
	#define SAFE_DELETE(p)			{ if (p) { delete (p);     (p) = NULL; } }	// delete
#endif //SAFE_DELETE

#ifndef SAFE_DELETE_ARRAY
	#define SAFE_DELETE_ARRAY(p)	{ if (p) { delete [] (p);  (p) = NULL; } }	// delete []
#endif //SAFE_DELETE_ARRAY

#ifndef SAFE_RELEASE
	#define SAFE_RELEASE(p)         { if (p) { (p)->release(p); (p) = NULL; } }
#endif //SAFE_RELEASE

//
#ifndef MALLOC
	#define MALLOC(size, count)		malloc(size * count);		// malloc
#endif //MALLOC

#ifndef SAFE_FREE
	#define SAFE_FREE(p)			{ if (p) { free(p);     (p) = NULL; } }		// free
#endif //SAFE_FREE


// singleton
#define DECLARE_SINGLETON(CLASS) \
	private: \
	static CLASS * singleton; \
	public: \
	static inline CLASS * instance() { return CLASS::singleton; }

#define IMPLEMENT_SINGLETON(CLASS) \
	CLASS * CLASS::singleton = NULL;


// base module
#define DECLARE_BASE_MODULE(CLASS) \
public: \
    CLASS * prev; \
    CLASS * next; \
    inline int release() { return IUnknown::release(); } \
    static int count; \
    static CLASS * first; \
    static CLASS * last; \
	static CLASS * mfind(const char * name); \
	static CLASS * mcreate(const char * name); \
    static CLASS * query(const char * name); \
    static void release(CLASS * data); \
	static void remove();

#define IMPLEMENT_BASE_MODULE(CLASS, NAME) \
int CLASS::count = 0; \
CLASS * CLASS::first = NULL; \
CLASS * CLASS::last = NULL; \
CLASS * CLASS::mfind(const char * name) \
{ \
    if (name) \
    { \
		CLASS * node = CLASS::first; \
        while (node) \
        { \
			char * _name = node->getName(); \
            if (_name && !strcmp(name, _name)) \
            { \
                node->addRef(); \
                return static_cast <CLASS *> (node->clone()); \
            } \
            node = node->next; \
        } \
    } \
	return NULL; \
} \
CLASS * CLASS::mcreate(const char * name) \
{ \
    const char * ext = NULL; \
    if (name) \
	{ \
        ext = _strchr(name, '.'); \
        if (name == ext) \
            ext = NULL; \
	} \
	CLASS * node = static_cast <CLASS *> (queryKernelModule(#NAME, ext)); \
	ASSERT(node) \
    node->setName(name); \
	node->next = NULL; \
	node->prev = CLASS::last; \
	if (CLASS::last) \
		CLASS::last->next = node; \
	if (!CLASS::first) \
		CLASS::first = node; \
	CLASS::last = node; \
	CLASS::count ++; \
    return node; \
} \
void CLASS::release(CLASS * node) \
{ \
	if (node->release()) \
        return; \
   	if (node == CLASS::first) \
		CLASS::first = CLASS::first->next; \
	CLASS * prev = node->prev; \
	CLASS * next = node->next; \
	if (prev) \
		prev->next = next; \
	else \
		CLASS::first = next; \
	if (next) \
		next->prev = prev; \
	else \
		CLASS::last = prev; \
	delete node; \
	node = NULL; \
	CLASS::count --; \
} \
void CLASS::remove() \
{ \
	CLASS * current = CLASS::last; \
	while (current) \
	{ \
		CLASS * prev = current->prev; \
		CLASS * next = current->next; \
		if (prev) \
			prev->next = next; \
		else \
			CLASS::first = next; \
		if (next) \
			next->prev = prev; \
		else \
			CLASS::last = prev; \
		delete current; \
		current = CLASS::last; \
	} \
	CLASS::count = 0; \
	CLASS::first = CLASS::last = NULL; \
}

/// CLASS * createNAME(const char * name);
#define DEFINE_BASE_MODULE(CLASS, NAME) \
	typedef CLASS * NAME; \
    inline CLASS * create##NAME(const char * name = NULL) \
    { \
        CLASS * clazz = CLASS::mfind(name); \
		if (clazz) \
			return clazz; \
		clazz = CLASS::mcreate(name); \
        return clazz; \
    }

/// CLASS * loadNAME(const char * pathName);
#define DEFINE_BASE_LOAD_MODULE(CLASS, NAME) \
    inline CLASS * load##NAME(const char * pathName) \
    { \
        CLASS * clazz = CLASS::mfind(pathName); \
		if (clazz) \
			return clazz; \
		clazz = CLASS::mcreate(pathName); \
        if (!clazz->loadFromFile(pathName)) \
        { \
            SAFE_RELEASE(clazz); \
            TRACE0(">> ERROR: load"#NAME"(%s)\n", pathName) \
            return NULL; \
        } \
        return clazz; \
    }


// module
#define DECLARE_MODULE(CLASS) \
	public: \
	static const char * mname; \
	static const char * mdescription; \
	static inline void * fnmcreate() { return new CLASS; }

#define IMPLEMENT_MODULE(CLASS, NAME) \
	const char * CLASS::mname = #NAME; \
	const char * CLASS::mdescription = #CLASS;


// dll module
#define DECLARE_DLL_MODULE(CLASS) \
	public: \
	static CLASS * pmodule; \
	static const char * mname; \

#define IMPLEMENT_DLL_MODULE(CLASS) \
	CLASS * CLASS::pmodule = NULL; \

#define DEFINE_DLL_MODULE(CLASS, NAME) \
	inline CLASS * NAME() \
	{ \
		return CLASS::pmodule; \
	}
	

// trace
#ifdef NDEBUG
	#if defined(_MSC_VER)
		#define TRACE(fmt, ...)
		#define TRACE0(fmt, ...)
		#define TRACE1(args)
	#else
		#define TRACE(fmt, args...)
		#define TRACE0(fmt, args...)
		#define TRACE1(args)
	#endif //_MSC_VER
	
	//
	#define ASSERT(p)
#else
	#if defined(_MSC_VER)
		#define TRACE(fmt, ...) outputDebugFormat(fmt, ##__VA_ARGS__);
		#define TRACE0(fmt, ...) outputDebugFormat("[%s:%d]\n"fmt, __FILE__, __LINE__, ##__VA_ARGS__);
		#define TRACE1(args) outputDebugString(args);
	#else
		#define TRACE(fmt, args...) outputDebugFormat(fmt, ##args);
		#define TRACE0(fmt, args...) outputDebugFormat("[%s:%d]\n"fmt, __FILE__, __LINE__, ##args);
		#define TRACE1(args) outputDebugString(args);
	#endif //_MSC_VER

	//
	#define ASSERT(p)	assert(p);
#endif //NDEBUG

//
extern LIBAPI const char * getTime();
extern LIBAPI const char * getBuildInfo();

//
extern LIBAPI void outputDebugFormat(const char * fmt, ...);
extern LIBAPI void outputDebugString(const char * string);

//
extern LIBAPI void initPath();
extern LIBAPI void setRootDirectory(const char * pathName);

//
extern LIBAPI void makeRootPath(char * pathName, const char * fileName);
extern LIBAPI void makeFullPath(char * pathName, const char * fileName);

//
extern LIBAPI void * loadFromFile(const char * pathName, size_t * length = NULL);

//
extern LIBAPI const char * _strchr(const char * str, int character);

#if defined(__GNUC__)
extern LIBAPI void _strrev(char * s);
extern LIBAPI void _strupr(char * s1);
extern LIBAPI void _strlwr(char * s1);
#endif //__GNUC__

//
extern LIBAPI int parseInt(const char * val);
extern LIBAPI float parseFloat(const char * val);
extern LIBAPI bool parseBool(const char * val);

//
extern LIBAPI float swapEndian(float val);
extern LIBAPI unsigned long swapEndian(unsigned long val);
extern LIBAPI unsigned int swapEndian(unsigned int val);
extern LIBAPI unsigned short swapEndian(unsigned short val);

#if defined(_LINUX) || defined(__APPLE__)
	extern long getTickCount();
#endif //_LINUX

#endif //STDAFX_H_
