/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */

#ifndef IFILE_H_
#define IFILE_H_

#include "iunknown.h"

namespace hydra
{

class LIBAPI IFile: public IUnknown
{
    DECLARE_BASE_MODULE(IFile)

public:
    IFile();

public:
    virtual bool open(const char * pathName, int mode);

    virtual size_t read(void * ptr, size_t count);
    virtual size_t write(void * ptr, size_t count);

    //
    virtual int seek(long offset, int origin);

    //
    virtual size_t getSize();

public:
    enum FILETYPE {
        CREATE = 0,
        READONLY,
        READWRITE,
    };

    enum SEEK {
        BEGIN = 0,
        CURRENT,
        END,
    };
};

//
DEFINE_BASE_MODULE(IFile, File)

} //hydra

#endif //IFILE_H_
