/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */

#ifndef IINPUT_H_
#define IINPUT_H_

#include "iunknown.h"

// User index definitions
#define USER_MAX_COUNT 4

#if defined(_PS3)
enum {
	BUTTON_SQUARE   = 0x00000001,
	BUTTON_CROSS	= 0x00000002,
	BUTTON_CIRCLE	= 0x00000004,
	BUTTON_TRIANGLE = 0x00000008,
	BUTTON_L1		= 0x00000010,
	BUTTON_R1		= 0x00000020,
	BUTTON_L2		= 0x00000040,
	BUTTON_R2		= 0x00000080,
	BUTTON_SELECT	= 0x00000100,
	BUTTON_START	= 0x00000200,
	BUTTON_L3		= 0x00000400,
	BUTTON_R3		= 0x00000800,
	BUTTON_UP		= 0x00001000,
	BUTTON_RIGHT	= 0x00002000,
	BUTTON_DOWN		= 0x00004000,
	BUTTON_LEFT		= 0x00008000,
	BUTTON_HOME		= 0x00010000,

	BUTTON_A		= BUTTON_CROSS,
	BUTTON_B		= BUTTON_CIRCLE,
	BUTTON_X		= BUTTON_SQUARE,
	BUTTON_Y		= BUTTON_TRIANGLE,
};
//#endif //_PS3
#elif defined(_XBOX)
enum {
	BUTTON_UP		= 0x00000001,
	BUTTON_DOWN		= 0x00000002,
	BUTTON_LEFT		= 0x00000004,
	BUTTON_RIGHT	= 0x00000008,
	BUTTON_START	= 0x00000010,
	BUTTON_BACK		= 0x00000020,
	BUTTON_L3		= 0x00000040,
	BUTTON_R3		= 0x00000080,
	BUTTON_L1		= 0x00000100,
	BUTTON_R1		= 0x00000200,
	BUTTON_L2		= 0x00000400,
	BUTTON_R2		= 0x00000800,
	BUTTON_A		= 0x00001000,
	BUTTON_B		= 0x00002000,
	BUTTON_X		= 0x00004000,
	BUTTON_Y		= 0x00008000,
	BUTTON_HOME		= 0x00010000,

	BUTTON_SQUARE   = BUTTON_X,
	BUTTON_CROSS	= BUTTON_A,
	BUTTON_CIRCLE	= BUTTON_B,
	BUTTON_TRIANGLE = BUTTON_Y,
};
//#endif //_XBOX
#else
enum {
	BUTTON_UP		= 0x00000001,
	BUTTON_DOWN		= 0x00000002,
	BUTTON_LEFT		= 0x00000004,
	BUTTON_RIGHT	= 0x00000008,
	BUTTON_START	= 0x00000010,
	BUTTON_BACK		= 0x00000020,
	BUTTON_L3		= 0x00000040,
	BUTTON_R3		= 0x00000080,
	BUTTON_L1		= 0x00000100,
	BUTTON_R1		= 0x00000200,
	BUTTON_L2		= 0x00000400,
	BUTTON_R2		= 0x00000800,
	BUTTON_A		= 0x00001000,
	BUTTON_B		= 0x00002000,
	BUTTON_X		= 0x00004000,
	BUTTON_Y		= 0x00008000,
	BUTTON_HOME		= 0x00010000,
	
	BUTTON_SQUARE   = BUTTON_X,
	BUTTON_CROSS	= BUTTON_A,
	BUTTON_CIRCLE	= BUTTON_B,
	BUTTON_TRIANGLE = BUTTON_Y,
};
#endif

namespace hydra
{

struct PadInfo {
	int padId;

	unsigned long buttons;
	int gyro;
	float x[3];
	float y[3];
	float z[3];
};

class LIBAPI IInput: public IUnknown
{
    DECLARE_BASE_MODULE(IInput)

public:
	IInput();
	virtual ~IInput();

public:
	virtual bool open(HWND hwnd);

	//
	virtual void update();

	//property
public:
	inline PadInfo * getPadInfo(int user)	{ return &m_padInfo[user]; }

protected:
	PadInfo m_padInfo[USER_MAX_COUNT];
};

//
DEFINE_BASE_MODULE(IInput, Input)

} //hydra

#endif //IINPUT_H_
