/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */

#include "graphics/icgshader.h"

#include "kernel.h"

#if defined(_NVCG)

namespace hydra
{

ICgShader::ICgShader()
{
    //
	m_ext = ".cg";

	m_vertexProgram = NULL;
	m_fragmentProgram = NULL;
}
ICgShader::~ICgShader()
{
	if (m_fragmentProgram)
	{
		cgDestroyProgram(m_fragmentProgram);
		m_fragmentProgram = NULL;
	}
	if (m_vertexProgram)
	{
		cgDestroyProgram(m_vertexProgram);
		m_vertexProgram = NULL;
	}
}

//
void ICgShader::setFloat(const char * name, const float value)
{
	CGparameter param = cgGetNamedParameter(m_vertexProgram, name);
	//if (param)
		cgSetParameter1f(param, value);
}
void ICgShader::setFloatArray(const char * name, const float * value, int count)
{

}
void ICgShader::setVector(const char * name, const float4 & value)
{
	CGparameter param = cgGetNamedParameter(m_vertexProgram, name);
	//if (param)
		cgSetParameter4fv(param, (float *) &value);
}
void ICgShader::setVectorArray(const char * name, const float4 * value, int count)
{

}
void ICgShader::setMatrix(const char * name, const float4x4 & value)
{
	CGparameter param = cgGetNamedParameter(m_vertexProgram, name);
	//if (param)
		cgSetMatrixParameterfr(param, (float *) &value);
}
void ICgShader::setMatrixArray(const char * name, const float4x4 * value, int count)
{

}

} //hydra

#endif //_NVCG
