/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */

#include "graphics/ishader.h"

#include "kernel.h"

namespace hydra
{

IMPLEMENT_BASE_MODULE(IShader, usr/lib/graphics/shader)

IShader::IShader()
{
	m_ext = NULL;
}

#include <string.h>
bool IShader::loadFromFile(const char * pathName)
{
	//TRACE("# IShader::loadFromFile(%s)", pathName)

	//
	char fullPath[MAX_PATH];
	makeFullPath(fullPath, pathName);

	char * ext = (char *) _strchr(fullPath, '.');
	strcpy(ext, m_ext);

	//
	size_t size;
	char * code = (char *) ::loadFromFile(fullPath, &size);
	if (!code)
		return false;

	code[size] = '\0';

	if (!loadFromMemory(code))
	{
		SAFE_FREE(code);
		return false;
	}
	SAFE_FREE(code);

	return true;
}

} //hydra
