/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/**
	@mainpage HYDRA
		http://www.enside.net/hydra\n\n\n

	@section intro intro
		HYDRA\n
		\n
		doxygen keyword\n
		@ + keyword \n
		\n
		remarks\n
		note\n
		param\n
		returns\n
		par\n
  		brief -> ///\n

	@section copyright copyright
		Copyright (c) 2004-2008 Enside, Inc.\n

	@section developer developer
		hunee (hunee@enside.net)

	@section history history
		- create 2008-01-17
*/


#include "stdafx.h"

#if defined(__APPLE__) || defined(_LINUX)
#include <sys/time.h>
long getTickCount()
{
	//get the current number of microseconds since january 1st 1970
	timeval ts;
	gettimeofday(&ts,0);
	return (ts.tv_sec * 1000 + (ts.tv_usec / 1000));
}
#endif //_LINUX


// log
#define TRACE_CONSOL
#define TRACE_FILE
#define TRACE_OUTPUT

static void _outputDebugString(const char * string)
{
#if defined(TRACE_CONSOL)
#if defined(_WIN32)
	static HANDLE logConsol = NULL;
	if (!logConsol)
	{
		AllocConsole();
		logConsol = GetStdHandle(STD_OUTPUT_HANDLE);
	}

	DWORD numberOfBytesWritten;
	if (!WriteConsole(logConsol, string, (DWORD) strlen(string), &numberOfBytesWritten, NULL))
	{
		printf("%s", string);
	}
#else
	printf("%s", string);
#endif //_WIN32
#endif //TRACE_CONSOL

//
#if defined(TRACE_FILE)
#if defined(_WIN32) || defined(_LINUX) || defined(__APPLE__)
	static const char * logName = "eventLog.txt";
	static FILE * logFile = NULL;
	if (!logFile)
	{
		logFile = fopen(logName, "wb");
		fclose(logFile);

		logFile = fopen(logName, "a");
	}

	fprintf(logFile, "%s", string);
	fflush(logFile);
#endif //_WIN32
#endif //TRACE_FILE

//
#if defined(TRACE_OUTPUT)
#if defined(_WIN32) || defined(_XBOX)
#if defined(_MSC_VER)
	OutputDebugString(string);
#endif //_MSC_VER
#endif //_WIN32
#if !defined(TRACE_CONSOL)
	printf("%s", string);
#endif //TRACE_CONSOL
#endif //TRACE_OUTPUT
}

#include <stdarg.h>

//"%s (%s, %d):: %s\n", __FUNCTION__, __FILE__, __LINE__, fullPath);
void outputDebugFormat(const char * fmt, ...)
{
	char buffer[MAX_PATH];

	// start
	va_list args;
	va_start(args, fmt);

	vsprintf(buffer, fmt, args);

	buffer[MAX_PATH - 1] = '\0';

	// end
	va_end(args);

	_outputDebugString(buffer);
}
void outputDebugString(const char * string)
{
	_outputDebugString(string);
	_outputDebugString("\n");
}

#include <time.h>

//
#define TIME_FORMAT		"%Y %B %d(%A) %p %I:%M:%S"
#define TIME_MAXLEN		(40)

const char * getTime()
{
	static char tbuffer[TIME_MAXLEN];

	// get the time before parsing args
	static time_t now;
	time(&now);

	static struct tm * tmnow = localtime(&now);
	if (!tmnow)
		strcpy(tbuffer, "?");
	else
		strftime(tbuffer, TIME_MAXLEN, TIME_FORMAT, tmnow);

	return tbuffer;
}

static char buildInfo[MAX_PATH] = {0, };
const char * getBuildInfo()
{
    return buildInfo;
}

static char rootPath[MAX_PATH];
void setRootDirectory(const char * pathName)
{
    strcpy(rootPath, pathName);
}

//
void initPath()
{
#if defined(_WIN32)
	GetCurrentDirectory(MAX_PATH, rootPath);

	size_t length = strlen(rootPath);
	if (rootPath[length] == '\\' || rootPath[length] == '/')
		rootPath[length] = '\0';
#else
    strcpy(rootPath, ".");
#endif //_WIN32

	//debug info
#if defined(_DEBUG) || !defined(NDEBUG)
	const char * debugInfo = "debug";
#else
	const char * debugInfo = "release";
#endif

	sprintf(buildInfo, "%s(%d) %s-%s(%s)", COMPILER_NAME, COMPILER_VER,
		PLATFORM, ARCH_TYPE == 32 ? "32" : "64",
		debugInfo);

	TRACE("\n*** %s - %s ***\n>> date - %s\n", PLATFORMNAME, buildInfo, getTime())
}

//
void makeRootPath(char * pathName, const char * fileName)
{
#if defined(_WIN32) || defined(_XBOX)
	wsprintf(pathName, "%s/%s", rootPath, fileName);

	int length = (int) strlen(pathName);
	for (int i=0; i<length; i++)
	{
		if (*pathName == '/')
			*pathName = '\\';

		pathName ++;
	}
//#endif //_WIN32
#else
	sprintf(pathName, "%s/%s", rootPath, fileName);
#endif //else
}
void makeFullPath(char * pathName, const char * fileName)
{
#if defined(_WIN32) || defined(_XBOX)
	wsprintf(pathName, "%s/media/%s", rootPath, fileName);

	int length = (int) strlen(pathName);
	for (int i=0; i<length; i++)
	{
		if (*pathName == '/')
			*pathName = '\\';

		pathName ++;
	}
//#endif //_WIN32
#else
	sprintf(pathName, "%s/media/%s", rootPath, fileName);
#endif //else
}

//
#include "system/ifile.h"

using namespace hydra;

//
void * loadFromFile(const char * pathName, size_t * length/* = NULL*/)
{
	File file = createFile();
	if (!file->open(pathName, IFile::READONLY))
    {
        SAFE_RELEASE(file);
        return NULL;
    }

	size_t size = file->getSize();
	void * buffer = MALLOC(size + 1, sizeof(char));
	ASSERT(buffer)

	size_t readbytes = file->read(buffer, size);
	ASSERT(readbytes == size)

	//
	if (length)
		*length = size;

    //
	SAFE_RELEASE(file);

	return buffer;
}

//
const char * _strchr(const char * str, int character)
{
	if (str == NULL)
		return NULL;
		
    char * ptr = (char *) str + (strlen(str) - 1);
    while (*ptr)
    {
        if (*ptr == character)
            return ptr;

        ptr --;
    }

    return str;
}

#if defined(__GNUC__)
void _strrev(char * s)
{
  	int len = strlen(s);
  	for (int i=0; i<len/2;++i)
  	{
    	char tmp = *(s + i);
    	*(s + i) = *(s + len - 1 - i);
    	*(s + len - 1 - i) = tmp;
  	}
}
void _strupr(char * s1)
{
  	while (*s1)
  	{
    	if (*s1 >= 97 && *s1 <= 122)
      		*s1 -= 32;
		  
    	s1 ++;
  	}
}
void _strlwr(char * s1)
{
  	while (*s1)
  	{
    	if (*s1 >= 65 && *s1 <= 90)
      		*s1 += 32;
		  
    	s1 ++;
  	}
}
#endif //__GNUC__

//
int parseInt(const char * val)
{
	int ret = (int) atoi(val);
	return ret;
}
float parseFloat(const char * val)
{
	float ret = (float) atof(val);
	return ret;
}
bool parseBool(const char * val)
{
	if (!strcmp(val, "true"))
		return true;

	return false;
}

//
float swapEndian(float val)
{
#if defined(__BIG_ENDIAN__)
	char buffer[ 4 ];
	char * value = (char *) &val;
	buffer[0] = value[3];
	buffer[1] = value[2];
	buffer[2] = value[1];
	buffer[3] = value[0];

	return *((float *) &buffer);
#else //__BIG_ENDIAN__
	return val;
#endif
}
//
unsigned long swapEndian(unsigned long val)
{
#if defined(__BIG_ENDIAN__)
	return ((val >> 24) & 0x000000ff) |
		((val >>  8) & 0x0000ff00) |
		((val <<  8) & 0x00ff0000) |
		((val << 24) & 0xff000000);
#else //__BIG_ENDIAN__
	return val;
#endif
}
unsigned int swapEndian(unsigned int val)
{
#if defined(__BIG_ENDIAN__)
	return ((val >> 24) & 0x000000ff) |
		((val >>  8) & 0x0000ff00) |
		((val <<  8) & 0x00ff0000) |
		((val << 24) & 0xff000000);
#else //__BIG_ENDIAN__
	return val;
#endif
}
unsigned short swapEndian(unsigned short val)
{
#if defined(__BIG_ENDIAN__)
	return ((val >>  8) & 0x00ff) | ((val <<  8) & 0xff00);
#else //__BIG_ENDIAN__
	return val;
#endif
}
