/*   SCE CONFIDENTIAL                                       */
/*   PLAYSTATION(R)3 Programmer Tool Runtime Library 200.002 */
/*   Copyright (C) 2007 Sony Computer Entertainment Inc.    */
/*   All Rights Reserved.                                   */

struct VS_INPUT
{
    float3 position : POSITION;
    float4 color    : COLOR0;
    float2 tex0     : TEXCOORD0;
};
struct VS_OUTPUT
{
    float4 position : POSITION;
    float4 color    : COLOR0;
    float2 tex0     : TEXCOORD0;
};

sampler TEX0 : register(s0);

VS_OUTPUT vs_main(VS_INPUT IN)
{
    VS_OUTPUT OUT;
    
    OUT.position = float4(IN.position, 1);
    OUT.color = IN.color; 
    OUT.tex0 = IN.tex0; 
    
    return OUT;
}

float4 ps_main(VS_OUTPUT IN) : COLOR0
{
	float4 color = tex2D(TEX0, IN.tex0) * IN.color;
    return color;
}

