/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */

#include "fmod4-voice.h"

#include "kernel.h"

namespace hydra
{
IMPLEMENT_MODULE(fmod4Voice, usr/lib/audio/voice)

fmod4Voice::fmod4Voice()
{
   	m_sound = NULL;
	m_channel = NULL;

	m_finished = true;
}

bool fmod4Voice::loadFromFile(const char * pathName)
{
	char fullPath[MAX_PATH];
	makeFullPath(fullPath, pathName);

    //
    char * ext = (char *) _strchr(fullPath, '.');
	strcpy(ext, ".mp3");

    FMOD_SYSTEM * system = _fmod4->getFMod();

    FMOD_RESULT result = FMOD_System_CreateStream(system, fullPath, FMOD_HARDWARE | FMOD_LOOP_NORMAL | FMOD_2D, 0, &m_sound);
	if (result != FMOD_OK)
	{
		char * chr = (char *) _strchr(fullPath, '.');
		strcpy(chr, ".wma");

		result = FMOD_System_CreateStream(system, fullPath, FMOD_HARDWARE | FMOD_LOOP_NORMAL | FMOD_2D, 0, &m_sound);
		if (result != FMOD_OK)
		{
			chr = (char *) _strchr(fullPath, '.');
			strcpy(chr, ".wav");

			result = FMOD_System_CreateStream(system, fullPath, FMOD_HARDWARE | FMOD_LOOP_NORMAL | FMOD_2D, 0, &m_sound);
			if (result != FMOD_OK)
				return false;
		}
	}

    return true;
}

//
bool fmod4Voice::play(int mode)
{
    FMOD_SYSTEM * system = _fmod4->getFMod();
    FMOD_System_PlaySound(system, FMOD_CHANNEL_FREE, m_sound, false, &m_channel);

	m_finished = false;

    return true;
}
void fmod4Voice::stop()
{
   	FMOD_Channel_Stop(m_channel);

    //
	m_finished = true;
}

//
void fmod4Voice::update()
{
   	FMOD_BOOL playing;
	FMOD_Channel_IsPlaying(m_channel, &playing);

    //
	m_finished = !playing;
}

} //hydra
