/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */

#include "fmod4.h"

#include "kernel.h"

namespace hydra
{
fmod4 * _fmod4 = NULL;

fmod4::fmod4()
{
    m_system = NULL;

	//
	_fmod4 = this;
}

fmod4::~fmod4()
{
    _fmod4 = NULL;

	//
	FMOD_System_Close(m_system);
    FMOD_System_Release(m_system);
}

bool fmod4::open(HWND hwnd)
{
    // create a system object and initialize.
	FMOD_RESULT result = FMOD_System_Create(&m_system);

	unsigned int version;
	result = FMOD_System_GetVersion(m_system, &version);
	if (version < FMOD_VERSION)
		return false;

	//
	result = FMOD_System_SetPluginPath(m_system, "./plugins");
	result = FMOD_System_Init(m_system, 1, FMOD_INIT_NORMAL, 0);

	//
	return IAudio::open(hwnd);
}

//
void fmod4::update()
{
    FMOD_System_Update(m_system);
}

} //hydra
