/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */

// #undef _USRDLL

#include "fmod4.h"

#include "fmod4-music.h"
#include "fmod4-voice.h"

#include "kernel.h"

#if defined (_MSC_VER)
	#pragma comment(lib, "hydra.lib")
#endif //_MSC_VER

namespace hydra
{

static MODULEINFO moduleInfo = {
	"fmod4",
	"FModEx4 audio module.",
	"AUDIO",
	"(c) 2004-2008 Enside, Inc. All rights reserved.",
	"hunee (hunee@enside.net)",
	"0.0.1",
};
LIBEXPORT const MODULEINFO * getModuleInfo()
{
	return &moduleInfo;
}

static IAudio * _audio = NULL;
LIBEXPORT void * loadModule()
{
	//
	_audio = new fmod4;
	if (_audio == NULL)
		return NULL;

   	registerKernelModule(fmod4Music);
	registerKernelModule(fmod4Voice);

	return _audio;
}
LIBEXPORT void unloadModule()
{
   	unregisterKernelModule(fmod4Music);
	unregisterKernelModule(fmod4Voice);

	SAFE_DELETE(_audio);
}

} //hydra

