/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */

#ifndef DIRECT3D9_INDEXBUFFER_H
#define DIRECT3D9_INDEXBUFFER_H

#include "graphics/iindexbuffer.h"

#include "direct3d9.h"

namespace hydra
{
	
class direct3d9Indexbuffer: public IIndexbuffer 
{
	DECLARE_MODULE(direct3d9Indexbuffer)

public:
	direct3d9Indexbuffer();
	virtual ~direct3d9Indexbuffer();

public:
	//
	bool create(int length, unsigned long format);

	//
	void * map();
	void unmap();

	//
	void bind();

	//
	void draw(int primitiveType);

	//
	void draw(int primitiveType, unsigned int startIndex, unsigned int indexCount, unsigned int numVertices);
	void draw(int primitiveType, unsigned int startVertex, unsigned int numVertices, unsigned int startIndex, unsigned int indexCount);

#if defined(_WIN32) || defined(_XBOX)
public:
	//
	inline void * getBuffer()
	{
		return m_buffer;
	}

private:
	LPDIRECT3DINDEXBUFFER9 m_buffer;
#endif //_WIN32
};

} //hydra

#endif //DIRECT3D9_INDEXBUFFER_H
