/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */

#ifndef DIRECT3D9_SAMPLER_H
#define DIRECT3D9_SAMPLER_H

#include "graphics/isampler.h"

#include "direct3d9.h"

namespace hydra
{

class direct3d9Sampler: public ISampler
{
	DECLARE_MODULE(direct3d9Sampler)
	
public:
	direct3d9Sampler();
	virtual ~direct3d9Sampler();
	
public:
	//
	bool create(int width, int height, unsigned long format, int mipLevels);

	//
	bool loadFromFile(const char * pathName);

    //
	void * map();
	void unmap();

#if defined(_WIN32) || defined(_XBOX)
public:
	inline int getLockPitch() { return m_locked.Pitch; }
	inline LPDIRECT3DTEXTURE9 getHandle() { return m_texture; }

protected:
	LPDIRECT3DTEXTURE9 m_texture;
	D3DLOCKED_RECT m_locked;
#endif //_WIN32
};

} //hydra

#endif //DIRECT3D9_SAMPLER_H
