/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */

#ifndef DIRECT3D9_SHADER_H
#define DIRECT3D9_SHADER_H

#include "graphics/ishader.h"

#include "direct3d9.h"

namespace hydra
{
	
class direct3d9Shader: public IShader 
{
	DECLARE_MODULE(direct3d9Shader)

public:
	direct3d9Shader();
	virtual ~direct3d9Shader();

public:
	//
	bool loadFromMemory(const char * code);
	bool loadFromMemory(const char * vpcode, const char * fpcode);

    //
	void begin();
	void end();

    //
	void setTransform(float4x4 & transform);

    //
	void setSampler(int stage, ISampler * sampler);
    void setSamplerState(unsigned long sampler, int type, unsigned long value);

	//
	void setFloat(const char * name, const float value);
	void setFloatArray(const char * name, const float * value, int count);

	void setVector(const char * name, const float4 & value);
	void setVectorArray(const char * name, const float4 * value, int count);

	void setMatrix(const char * name, const float4x4 & value);
	void setMatrixArray(const char * name, const float4x4 * value, int count);

#if defined(_WIN32) || defined(_XBOX)
protected:
	LPDIRECT3DPIXELSHADER9 m_fragmentShader;
	LPDIRECT3DVERTEXSHADER9 m_vertexShader;

	// Rhe constant table structure which will be created by D3DXCompileShader
	LPD3DXCONSTANTTABLE m_fragmentConstTable;
	LPD3DXCONSTANTTABLE m_vertexConstTable;
#endif //_WIN32
};

} //hydra

#endif //DIRECT3D9_SHADER_H
