/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */

#ifndef DIRECT3D9_VERTEXBUFFER_H
#define DIRECT3D9_VERTEXBUFFER_H

#include "graphics/ivertexbuffer.h"

#include "direct3d9.h"

namespace hydra
{

class direct3d9Vertexbuffer: public IVertexbuffer
{
	DECLARE_MODULE(direct3d9Vertexbuffer)

public:
	direct3d9Vertexbuffer();
	virtual ~direct3d9Vertexbuffer();

public:
	//
	bool create(int length, unsigned long fvf);

	//
	void * map();
	void unmap();

	//
	void bind();

	//
	void draw(int primitiveType);
	void draw(int primitiveType, unsigned int startVertex, unsigned int vertexCount);

#if defined(_WIN32) || defined(_XBOX)
private:
	LPDIRECT3DVERTEXBUFFER9	m_buffer;
	LPDIRECT3DVERTEXDECLARATION9 m_decl;
#endif //_WIN32
};

}

#endif //DIRECT3D9_VERTEXBUFFER_H
