/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */

#ifndef OPENGL_INDEXBUFFER_H_
#define OPENGL_INDEXBUFFER_H_

#include "graphics/iindexbuffer.h"

#include "opengl.h"

namespace hydra
{

class openglIndexbuffer: public IIndexbuffer
{
	DECLARE_MODULE(openglIndexbuffer)

public:
	openglIndexbuffer();
	virtual ~openglIndexbuffer();

public:
	bool create(int length, unsigned long format);

    //
	void * map();
	void unmap();

	//
	void bind();

	//
	void draw(int primitiveType);

	void draw(int primitiveType, unsigned int startIndex, unsigned int indexCount, unsigned int numVertices);
	void draw(int primitiveType, unsigned int startVertex, unsigned int numVertices, unsigned int startIndex, unsigned int indexCount);

	//
	inline void * buffer()
	{
		return m_buffer;
	}

private:
	void * m_buffer;
	GLuint m_objectId;
};

} //hydra

#endif //OPENGL_INDEXBUFFER_H_
