/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */

#ifndef OPENGLSAMPLER_H
#define OPENGLSAMPLER_H

#include "graphics/isampler.h"

#include "opengl.h"

namespace hydra
{

class openglSampler: public ISampler
{
	DECLARE_MODULE(openglSampler)

public:
	openglSampler();
	virtual ~openglSampler();

public:
	bool create(int width, int height, unsigned long format, int mipLevels);

	//
	void * map();
	void unmap();

    //
	inline GLuint getHandle()
	{
		return m_texture;
	}
	inline GLenum getTarget()
	{
		return m_target;
	}
	
private:
	GLuint m_texture;
	GLenum m_target;
	
	void * m_bits;
};

} //hydra

#endif //OPENGLSAMPLER_H
