/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */

#ifndef OPENGL_SHADER_H_
#define OPENGL_SHADER_H_

#include "graphics/ishader.h"

#include "opengl.h"

namespace hydra
{

class openglShader: public IShader
{
	DECLARE_MODULE(openglShader)

public:
	openglShader();
	virtual ~openglShader();

public:
	bool loadFromMemory(const char * code);
	bool loadFromMemory(const char * vpcode, const char * fpcode);

	void begin();
	void end();

	void setSampler(int stage, ISampler * sampler);
	void setSamplerState(unsigned long sampler, int type, unsigned long value);

	//
	void setFloat(const char * name, const float value);
	void setFloatArray(const char * name, const float * value, int count);

	void setVector(const char * name, const float4 & value);
	void setVectorArray(const char * name, const float4 * value, int count);

	void setMatrix(const char * name, const float4x4 & value);
	void setMatrixArray(const char * name, const float4x4 * value, int count);

private:
	GLhandleARB m_programObject;

};

} //hydra

#endif //OPENGLSHADER_H_
