/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */

#ifndef OPENGL_VERTEXBUFFER_H_
#define OPENGL_VERTEXBUFFER_H_

#include "graphics/ivertexbuffer.h"

#include "opengl.h"

namespace hydra
{

class openglVertexbuffer: public IVertexbuffer
{
	DECLARE_MODULE(openglVertexbuffer)

public:
	openglVertexbuffer();
	virtual ~openglVertexbuffer();

public:
	//
	bool create(int length, unsigned long fvf);

    //
	void * map();
	void unmap();

	//
	void bind();

	//
	void draw(int primitiveType);
	void draw(int primitiveType, unsigned int startVertex, unsigned int vertexCount);

private:
	void * m_buffer;
	GLuint m_objectId;
};

}

#endif //OPENGL_VERTEXBUFFER_H_
