/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */

#ifndef INPUT_DINPUT8_H
#define INPUT_DINPUT8_H

#include "system/iinput.h"

#if defined(_WIN32)

#define DIRECTINPUT_VERSION 0x0800
#include <dinput.h>

#if defined (_MSC_VER)
	#pragma comment (lib, "dinput8.lib")
	#pragma comment(lib, "dxguid.lib")
#endif //_MSC_VER

namespace hydra
{

class inputDInput8: public IInput
{
	DECLARE_MODULE(inputDInput8)

public:
	inputDInput8();
	virtual ~inputDInput8();

public:
	bool open(HWND hwnd);

	void update();

private:
	LPDIRECTINPUT8 m_input;
	LPDIRECTINPUTDEVICE8 m_device;

private:
	bool m_initialize;

	bool initialize(HWND hwnd);
};

} //hydra

#endif //_WIN32

#endif //INPUT_DINPUT8_H
