/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */

// #undef _USRDLL

#include "input-xinput.h"

#include "file-win32.h"

#include "moduleinfo.h"

#if defined (_MSC_VER)
	#pragma comment(lib, "hydra.lib")
#endif //_MSC_VER

namespace hydra
{

static MODULEINFO moduleInfo = {
	"xinput",
	"Microsoft XInput input module.",
	"INPUT",
	"(c) 2004-2008 Enside, Inc. All rights reserved.",
	"hunee (hunee@enside.net)",
	"0.0.1",
};
LIBEXPORT const MODULEINFO * getModuleInfo()
{
	return &moduleInfo;
}

//
static IInput * _input = NULL;
LIBEXPORT void * loadModule()
{
	_input = new inputXInput;
	if (_input == NULL)
		return NULL;

	registerKernelModule(fileWin32);

	return _input;
}
LIBEXPORT void unloadModule()
{
	unregisterKernelModule(fileWin32);

	SAFE_DELETE(_input);
}

} //hydra

