/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */

#include "window-linux.h"

#include "kernel.h"

#if defined(_LINUX)

namespace hydra
{

IMPLEMENT_MODULE(windowLinux, usr/lib/window)

windowLinux::windowLinux()
{
}
windowLinux::~windowLinux()
{
	if (m_hwnd)
	{
		XCloseDisplay(m_hwnd);
		m_hwnd = NULL;
	}
}

//
bool windowLinux::create(int width, int height, const char * title)
{
	m_hwnd = XOpenDisplay(NULL);
	if (m_hwnd == NULL)
	    return false;

	return true;
}

//
int kernelLinux::run()
{
	XEvent event;

	//
	int running = 1;
	while (running)
	{
		while (XPending(m_hwnd) > 0)
		{
			XNextEvent(m_hwnd, &event);

			switch (event.type)
			{
			case Expose:
				if (event.xexpose.count != 0)
					break;
				break;

			case ConfigureNotify:
				if (IGraphics::pmodule != NULL)
					graphicsModule()->setViewport(0, 0, event.xconfigure.width, event.xconfigure.height);
				break;

			case KeyPress:
				switch (XLookupKeysym(&event.xkey,0))
				{
				case XK_Escape:									/* Quit application */
					running = 0;
					break;
				case XK_F1:
					break;
				}
				break;

			case KeyRelease:
				break;

			case ClientMessage:
				if (*XGetAtomName(m_hwnd, event.xclient.message_type) == *"WM_PROTOCOLS")
				{
					running = 0;
				}
				break;

			default:
				break;
			}
		}

		if (!idle())
        	break;
	}

	return 0;
}

} //hydra

#endif //_LINUX
