/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */

#ifndef CAMERA_H_
#define CAMERA_H_

#include "iunknown.h"

#include "graphics/vector.h"

namespace hydra
{

class Camera: public IUnknown {
public:
	Camera();

public:
	void setRotationYawPitchRoll(const float yaw, const float pitch, const float roll);

	//
	void setLookAt(const float3 & eye, const float3 & lookAt, const float3 & up);
	void setPerspectiveFov(const float fovy, const float aspect, const float zNear, const float zFar);

	//property
public:
	void setPos(const float3 & pos);
	float3 getPos() { return float3(m_view._41, m_view._42, m_view._43); }

	//
	inline float4x4 & getViewMatrix() { return m_view; }
	inline float4x4 & getProjectionMatrix() { return m_projection; }

	// Globle value
protected:
	float4x4 m_view;
	float4x4 m_projection;
};

} //hydra

#endif //CAMERA_H_
