/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */

#ifndef MY_VIEW_H_
#define MY_VIEW_H_

#include "iview.h"

#include "audio/ivoice.h"
#include "audio/imusic.h"

#include "graphics/isampler.h"

#include "graphics/imesh.h"

#include "camera.h"

#define MAX_SPRITES	(6)

class myView: public hydra::IView {
public:
	myView();
    virtual ~myView();

public:
    void destroy();

    //
    bool loadData();

    //
    bool update(float deltaTime);
    void draw();

private:
    hydra::IVoice * m_voice;
    hydra::IMusic * m_music;

	hydra::ISampler * m_sampler[MAX_SPRITES];

	hydra::ISampler * m_logo;
	hydra::IMesh * m_mesh;
	hydra::Camera m_camera;

	hydra::float3 m_pos, m_axis;
};

#endif //MY_VIEW_H_
